(function($) {
    $.fn.extend({
        leanModal : function(options) {
            var defaults = {
                top : 100,
                overlay : 0.5,
                closeButton : null,
                modalId : "",
                onCloseCallback : function() {
                }
            };
            var overlay = $("#lean_overlay");
            if (!overlay || overlay.length == 0) {
                overlay = $("<div id='lean_overlay'></div>");
            }
            $("body").append(overlay);
            options = $.extend(defaults, options);
            return this.each(function() {
                var o = options;
                var modal_id = "#" + o.modalId;
                $("#lean_overlay").click(function() {
                    close_modal(modal_id)
                });
                $(o.closeButton).click(function() {
                    close_modal(modal_id)
                });
                var modal_height = $(modal_id).outerHeight();
                var modal_width = $(modal_id).outerWidth();
                $("#lean_overlay").css({
                    "display" : "block",
                    opacity : 0
                });
                $("#lean_overlay").fadeTo(200, o.overlay);
                $(modal_id).css({
                    "display" : "block",
                    "position" : "fixed",
                    "opacity" : 0,
                    "z-index" : 11000,
                    "left" : 50 + "%",
                    "margin-left" : -(modal_width / 2) + "px",
                    "top" : o.top + "px"
                });
                $(modal_id).fadeTo(200, 1);
            });
            function close_modal(modal_id) {
								if($("#resultArea").css('display') == 'block') {
									options.onCloseCallback();
									return;
								}
                $.confirm({
                    'title' : '博士',
                    'message' : 'もうおしまいかの？<br/>作ったプログラムは消えてしまうぞ',
                    'buttons' : {
                        '終わる' : {
														'class' : 'btn-small commandButton confirm',
                            'action' : function() {
                                if (options.onCloseCallback()) {
                                    $("#lean_overlay").fadeOut("normal", function() {
                                         $("#lean_overlay").remove();
                                    });
                                }
																$(".code").html("");
                            }
                        },
                        'まだ作る' : {
														'class' : 'btn-small commandButton confirm',
                            'action' : function(target) {
                            }
//                        },
//                        '保存して終わる' : {
//														'class' : 'btn-small commandButton wide confirm',
//                            'action' : function(target) {
//                                if (options.onCloseCallback()) {
//                                    $("#lean_overlay").fadeOut("normal").queue(function() {
//                                         $("#lean_overlay").remove();
//                                    });
//                                }
//																saveEditor();
																//FIXME cookieにエリアごとに保存する
//                            }
                        }
                    }
                });
            }
        }
    })
})(jQuery);